// ArduCAM GPIO Read demo (C)2013 Lee
// web: http://www.ArduCAM.com
// This program is a demo of how to use GPIOs in ArduCAM to read 
// trigger signals from any ohter devices.
//
// This program requires the ArduCAM library.
//
#include <Wire.h>
#include <ArduCAM.h>
#include <avr/pgmspace.h>
#include <SoftwareSerial.h>


//ArduCAM(byte model,int RS, int WR, int RD, int REG_CS, int FIFO_CS)
ArduCAM myCAM(OV7670,A2,A1,A0,A3,10);
//Uncomment if use software serial
SoftwareSerial mySerial(9, 8); // RX, TX
void setup()
{
  mySerial.begin(9600);
  mySerial.println("AruCAM GPIO Testing Program Start...");
  
}


void loop()
{
  uint8_t temp;
  uint8_t val = 0x55;
  uint8_t read_val;
  
  temp = myCAM.read_reg(ARDUCHIP_REV);
  mySerial.println("ArduChip Revision : ");
  mySerial.write(temp>>6);
  mySerial.write(temp & 0x2F);
  mySerial.println(" ");
      
  mySerial.println("GPIO Output Test Start...");
  delay(1000);
  
  myCAM.write_reg( ARDUCHIP_DDR, 0xff);     //Set GPIO as output
  mySerial.println("GPIO Output 0 ON");
  myCAM.write_reg( ARDUCHIP_PORT, 0xFE);       //Output Register
  delay(1000);
  mySerial.println("GPIO Output 0 OFF");
  myCAM.write_reg( ARDUCHIP_PORT, 0xFF);       //Output Register
  delay(1000);
  
  mySerial.println("GPIO Output 1 ON");
  myCAM.write_reg( ARDUCHIP_PORT, 0xFD);       //Output Register
  delay(1000);
  mySerial.println("GPIO Output 1 OFF");
  myCAM.write_reg( ARDUCHIP_PORT, 0xFF);       //Output Register
  delay(1000);
  
  mySerial.println("GPIO Output 2 ON");
  myCAM.write_reg( ARDUCHIP_PORT, 0xFB);       //Output Register
  delay(1000);
  mySerial.println("GPIO Output 2 OFF");
  myCAM.write_reg( ARDUCHIP_PORT, 0xFF);       //Output Register
  delay(1000);
  
  mySerial.println("GPIO Output 3 ON");
  myCAM.write_reg( ARDUCHIP_PORT, 0xF7);       //Output Register
  delay(1000);
  mySerial.println("GPIO Output 3 OFF");
  myCAM.write_reg( ARDUCHIP_PORT, 0xFF);       //Output Register
  delay(1000);
  
  mySerial.println("GPIO Output 4 ON");
  myCAM.write_reg( ARDUCHIP_PORT, 0xEF);       //Output Register
  delay(1000);
  mySerial.println("GPIO Output 4 OFF");
  myCAM.write_reg( ARDUCHIP_PORT, 0xFF);       //Output Register
  delay(1000);
  
  mySerial.println("GPIO Output 5 ON");
  myCAM.write_reg( ARDUCHIP_PORT, 0xDF);       //Output Register
  delay(1000);
  mySerial.println("GPIO Output 5 OFF");
  myCAM.write_reg( ARDUCHIP_PORT, 0xFF);       //Output Register
  delay(1000);
  
  
  myCAM.write_reg( ARDUCHIP_DDR, 0x00);     //Set GPIO as input
  
  while(1)
  {
  	
    temp = myCAM.read_reg(ARDUCHIP_PIN);      //Read from GPIO
    //mySerial.write(temp);                  //Send value read from GPIO
    switch (temp)
    {
      case 0x3E:
        mySerial.println("Button 0 is pressed");
        break;
      case 0x3D:
        mySerial.println("Button 1 is pressed");
        break;
      case 0x3B:
        mySerial.println("Button 2 is pressed");
        break;
      case 0x37:
        mySerial.println("Button 3 is pressed");
        break;
      case 0x2F:
        mySerial.println("Button 4 is pressed");
        break;
      case 0x1F:
        mySerial.println("Button 5 is pressed");
        break;
      default:
        mySerial.write(temp);
        break;
    }  
    delay(100);
  }
  return;
  
}



